#ifndef _UNICODE
#define _UNICODE
#endif
#ifndef UNICODE
#define UNICODE
#endif
#include <windows.h>
#include <tchar.h>
#include "DirectShowWriter.h"

void test(void);

int main(int argc, char* argv[])
{
	CoInitializeEx(NULL, COINIT_MULTITHREADED);

	test();

	CoUninitialize();

	return 0;
}

void test(void)
{
	cv::Mat image(480, 640, CV_8UC4);
	
	auto dsw = std::shared_ptr<DirectShowWriter>(DirectShowWriter::GetInstance(), [](DirectShowWriter* p){p->Destroy();});

	// t@C NULL ɂƁAsɑI_CAOJB
	//  2 ͌ݖB
	// type  CV_8UC3/CV_8UC4 ȊO͑ΉB
	if(!dsw->Open(L"test.avi", NULL, 29.97, image.size(), image.type(), true))
	{
		wprintf(L"%s\n", dsw->GetLastErrorString());
		return;
	}
	
	for(int b = 0; b <= 256; b += 16)
	{
		for(int g = 0; g < 256; g += 16)
		{
			for(int r = 0; r < 256; r += 16)
			{
				image = cv::Scalar(b, g, r, 128);
				dsw->Write(image);
			}
		}
	}
	image = cv::Scalar(0, 0, 0);
	dsw->Write(image);
	
	dsw->Close();		// Destroy ̒ Close ͌Ă΂̂ŁAȂĂ悢B
}
